var oQuote;
var oPanel;
var curShowState = false;
function checkQuote(tips, imageUrl) {
	var oDoc = document;

    oQuote = checkCommon() || checkQQ() || checkYahoo() || checkLiveWebmail() || checkLiveMail();
	if (typeof oQuote === 'object') {
		oPanel = document.createElement('div');
		oPanel.id = 'ntes-mail-android-quote-controller';
    //oPanel.style.backgroundImage = "url("+imageUrl+")";
		oQuote.parentNode.insertBefore(oPanel, oQuote);
		toggleQuote(curShowState, false);

		var oController = document.getElementById('ntes-mail-android-quote-controller');
		oController.addEventListener("click", function() {
            toggleQuote(!curShowState, true);
		});
	}

    function getStyle(oDiv) {
        try {
            var oStyle = oDiv.getAttribute('style');
            return (oStyle.cssText || oStyle).toLowerCase().replace(/[ \']/gi, '');
        } catch (e) {
        }
        return '';
    }

    function checkCommon() {
        try {
            var aQuotes = oDoc.getElementsByTagName('BLOCKQUOTE');
            for (var i = 0, oQuote; i < aQuotes.length; i += 1) {
                oQuote = aQuotes[i];
                // Netease
                if (oQuote.id === 'isReplyContent') {
                    return oQuote;
                }
                // Netease mail clients
                if (oQuote.id === 'ntes-flashmail-quote' ||
                    oQuote.id === 'ntes-iosmail-quote' ||
                    oQuote.id === 'ntes-andriodmail-quote') {
                    return oQuote;
                }
                // Gmail
                if (oQuote.className === 'gmail_quote') {
                    return oQuote;
                }
                // Thunder bird
                if (oQuote.parentNode === oDoc.body && oQuote.type === 'cite' && oQuote.getAttribute('cite').indexOf('mid') === 0) {
                    return oQuote;
                }
            }
        } catch (e) {
        }
        return false;
    }

    function checkQQ() {
        try {
            var aDivList = oDoc.getElementsByTagName('DIV');
            for (var i = 0, oDiv, oParent; i < aDivList.length; i += 1) {
                oDiv = aDivList[i];
                if (oDiv.innerHTML === '------------------&nbsp;原始邮件&nbsp;------------------') {
                    oParent = oDiv.parentNode;
                    if (oParent.parentNode === oDoc.body.childNodes[1]) {
                        return oParent;
                    }
                }
            }
        } catch (e) {
        }
        return false;
    }

    function checkYahoo() {
        try {
            var oFirstChild = oDoc.body.firstChild;
            var sStyle = 'font-family:timesnewroman,newyork,times,serif;font-size:12pt';
            if (getStyle(oFirstChild) === sStyle && getStyle(oFirstChild.childNodes[1]) === sStyle && getStyle(oFirstChild.childNodes[1].childNodes[1]) === sStyle) {
                return oFirstChild.childNodes[1].childNodes[1];
            }
            return false;
        } catch (e) {
        }
        return false;
    }

    function checkLiveWebmail() {
        try {
            var oHr = oDoc.getElementsByTagName('HR')[0],
                oQuote;

            if (oHr && oHr.id === 'stopSpelling') {
                var aChildList = oDoc.body.childNodes;

                for (var j = 0, nLen = aChildList.length, oItem; j < nLen; j += 1) {
                    oItem = aChildList[j];
                    if (oItem === oHr) {
                        oQuote = oDoc.createElement('DIV');
                        oHr.parentNode.insertBefore(oQuote, oHr);
                        oQuote.appendChild(oItem);
                    }
                    else {
                        if (oQuote) {
                            oQuote.appendChild(oItem);
                        }
                    }
                }
            }

            return oQuote;
        } catch (e) {
        }
        return false;
    }

    function checkLiveMail() {
        try {
            var oDiv = oDoc.body.childNodes[1],
                oQuote;

            if (getStyle(oDiv) === 'font:10pttahoma' && getStyle(oDiv.childNodes[1]) === 'background:#f5f5f5' && oDiv.childNodes[1].childNodes.length === 4) {
                var aChildList = oDoc.body.childNodes;

                for (var j = 0, nLen = aChildList.length, oItem; j < nLen; j += 1) {
                    oItem = aChildList[j];
                    if (oItem === oDiv) {
                        oQuote = oDoc.createElement('DIV');
                        oDiv.parentNode.insertBefore(oQuote, oDiv);
                        oQuote.appendChild(oItem);
                    }
                    else {
                        if (oQuote) {
                            oQuote.appendChild(oItem);
                        }
                    }
                }
            }

            return oQuote;
        } catch (e) {
        }
        return false;
    }
}

function toggleQuote(show, isClick){
    curShowState = show;
    if(!!oQuote){
        oQuote.style.display = show ? '' : 'none';
        if (isClick) {
            prompt(JSON.stringify({name:"$NE-MAIL-APP-TOGGLE-PANEL$",show:curShowState}));
        } else {
            prompt(JSON.stringify({name:"$NE-MAIL-APP-TOGGLE-PANEL$"}));
        }

        /**
        * toggle panel 时需要回调FKWebView做高度调整,.
        * 使用setTimeout来触发延时任务,保证display 的流程完成后再回调webview, 否则quote元素过多, webview layout的时候会产生元素压缩的情况
        */
       dispatchNativeLayout();
    }
}

function changeToggleContent(show, hide){
    if(!!oQuote){
        if (oQuote.style.display == "none") {
            oPanel.innerHTML = '<div style="color: #81858a;font-size: 14px;line-height: 1;margin: 45px 0 20px 0;">\n' +
                                        '<span style="margin: 0 0 0 6.5px;">'+show+'</span>\n' +
                                        '<div style="display: inline-block;width: 6px;height: 6px;margin: 3px 0;-webkit-transform: translate(1px, 0px) rotate(135deg);transform: translate(1px, 0px) rotate(135deg);position: relative;font-size: 0;">\n' +
                                            '<span class="arrow-l" style="width: 100%;height: 2px;display: block;background-color: #c9cacc;border-radius: 1px;position: absolute;left: 0;top: 0;"></span>\n' +
                                            '<span class="arrow-r" style="width: 2px;height: 100%;background-color: #c9cacc;display: block;border-radius: 1px;position: absolute;right: 0;top: 0;"></span>\n' +
                                        '</div>\n' +
                                    '</div>';
        } else {
            oPanel.innerHTML = '<div style="color: #81858a;font-size: 14px;line-height: 1;margin: 45px 0 20px 0;">\n' +
                                       '<span style="margin: 0 0 0 6.5px;">'+hide+'</span>\n' +
                                       '<div style="display: inline-block;width: 6px;height: 6px;vertical-align: middle;-webkit-transform: translate(1px, 0px) rotate(-45deg);transform: translate(1px, 0px) rotate(-45deg);position: relative;font-size: 0;">\n' +
                                           '<span class="arrow-l" style="width: 100%;height: 2px;display: block;background-color: #c9cacc;border-radius: 1px;position: absolute;left: 0;top: 0;"></span>\n' +
                                           '<span class="arrow-r" style="width: 2px;height: 100%;background-color: #c9cacc;display: block;border-radius: 1px;position: absolute;right: 0;top: 0;"></span>\n' +
                                       '</div>\n' +
                                   '</div>';
        }
        reScale();
    }
}
